      subroutine chooser
      implicit none
      include 'types.f'
c---- Note added 4/21/03
c---- plabel set to 'ig' (for 'ignore') means that this
c---- particle should not be subject to any cuts, so that the
c---- total cross-section comes out correctly when the BR is removed
      
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'masses.f'
      include 'ewcharge.f'
      include 'zcouple.f'
      include 'vegas_common.f'
      include 'zerowidth.f'
      include 'removebr.f'
      include 'bbproc.f'
      include 'nwz.f'
      include 'kprocess.f'
      include 'flags.f'
      include 'heavyflav.f'
      include 'nflav.f'
      include 'nodecay.f'
      include 'stopscales.f'
      include 'scale.f'
      include 'facscale.f'
      include 'nlooprun.f'
      include 'b0.f'
      include 'colstruc.f'
      include 'stopbmass.f'
      include 'fourthgen.f'
      include 'anomcoup.f'
      include 'srdiags.f'
      include 'clustering.f'
      include 'frag.f'
      include 'plabel.f'
      include 'interference.f'
      include 'couple.f'
      include 'kpart.f'
      include 'hdecaymode.f'
      include 'breit.f'
      include 'mcfmplotinfo.f'
      include 'lastphot.f'
      include 'new_pspace.f'
      include 'dm_params.f'
      include 'swapxz.f'
      include 'verbose.f'
      include 'runstring.f'
      include 'vdecayid.f'
      include 'ipsgen.f'
      include 'nuflav.f'
      include 'nqcdjets.f'
      include 'bitflags.f'
      include 'nproc.f'
      include 'notag.f'
      include 'VVstrong.f'
      include 'taucut.f'
      include 'mpicommon.f'
      include 'noglue.f'
      include 'toploopgaga.f'
      real(dp):: wwbr,zzbr,tautaubr,gamgambr,zgambr,Rcut,Rbbmin,
     & alphas,cmass,bmass
      real(dp):: br,BrnRat,brwen,brzee,brznn,brtau,brtop,brcharm
      integer:: mproc,j,isub,ilomomenta
      logical :: reset_alphaEM
      character*100 pname
      character*1 order
      character*72 string
      character*82 pwrite
      real(dp):: Vud,Vus,Vub,Vcd,Vcs,Vcb
      common/cabib/Vud,Vus,Vub,Vcd,Vcs,Vcb
      common/Rbbmin/Rbbmin
      common/Rcut/Rcut
      common/BrnRat/BrnRat
      common/isub/isub
      common/ilomomenta/ilomomenta
      common/qmass/cmass,bmass
      data hdecaymode/'xxxx'/
     
      do j=1,mxpart
      plabel(j)=''
      enddo

      do j=1,50
      mcfmplotinfo(j)=-1
      enddo

      string='process.DAT' 
      open(unit=21,file=string,status='old',err=43)
      call checkversion(21,string)
      
      if (verbose) write(6,*) 'Chooser:process chosen by nproc=',nproc

      do j=1,600
      read(21,*,err=44) mproc,pname,order
      
      if (rank.eq.0) then
         if (nproc < 0) then 
            write(6,*) mproc,pname 
         endif
      endif
      if (mproc == nproc) go to 42
      if (pname == 'EOF') go to 44
      enddo
      goto 44

 42   continue
      if (rank.eq.0) then
         if (verbose) then
       write(6,*)
       write(6,*) '*************************** f(p1)+f(p2) --> *****'//
     .           '*************************************'
      j=index(pname,'[')
      if (j > 101) j=101
      if (j > 0) then
        pwrite=adjustl(pname(19:j-1))
        write(6,99) pwrite
        pwrite=adjustl(pname(j:len(pname)))
        write(6,99) pwrite
      else
        pwrite=adjustl(pname(19:100))
        write(6,99) pwrite
      endif
      write(6,*) '*************************************************'//
     & '*************************************'
      write(6,*)
      endif
      endif
      close(unit=21)

c--- check no. of momenta appearing in LO process, fill ilomomenta common block
      if (index(pname,'p3') > 0)  ilomomenta=3
      if (index(pname,'p4') > 0)  ilomomenta=4
      if (index(pname,'p5') > 0)  ilomomenta=5
      if (index(pname,'p6') > 0)  ilomomenta=6
      if (index(pname,'p7') > 0)  ilomomenta=7
      if (index(pname,'p8') > 0)  ilomomenta=8
      if (index(pname,'p9') > 0)  ilomomenta=9
      if (index(pname,'p10') > 0) ilomomenta=10
      if (index(pname,'p11') > 0) ilomomenta=11
      if (index(pname,'p12') > 0) ilomomenta=12
      
      plabel(1)='pp'
      plabel(2)='pp'

c--- the default behaviour is to remove no branching ratio
      BrnRat=1._dp

c--- set up most parameters
      call coupling
      
      notag=0
      nqcdjets=0
      isub=0
      bbproc=.false.
      nodecay=.false.
      nfonly=.false.
      caonly=.false.
      fourthgen=.false.
      rescale=.false.
      doipsgen=.false.
      reset_alphaEM=.false.
      lastphot=-1
c--- default is no interference contributions from identical fermions
      interference=.false.
      vsymfact=1._dp
c--- default is weak process
      VVstrong=.false.

c-- Rbbmin is an additional variable, added so that the separation
c-- between two b jets can be controlled separately from the Delta_R
c-- cut between any other types of jet
c-- Default behaviour: the same value as for the other jets
      Rbbmin=Rcut
      
c-----------------------------------------------------------------------

        kcase=kW_only
        mass3=wmass
        width3=wwidth
        n3=1
        ndim=4
        nqcdjets=0

        mcfmplotinfo= (/ 34, (0,j=1,49) /)

      if ((nproc == 1) .or. (nproc == 6)) then
c---W^+
        if     (nproc == 1) then
C-- 1  '  f(p1)+f(p2) --> W^+(-->nu(p3)+e^+(p4))'
C--    '  f(p1)+f(p2) --> W^+ (for total Xsect)' (removebr=.true.)
          plabel(3)='nl'
          plabel(4)='ea'
          plabel(5)='pp'
          nwz=1
c---W^-
        elseif (nproc == 6) then
c-- 6  '  f(p1)+f(p2) --> W^-(-->e^-(p3)+nu~(p4))'
c--    '  f(p1)+f(p2) --> W^- (for total Xsect)' (removebr=.true.)
          plabel(3)='el'
          plabel(4)='na'
          plabel(5)='pp'
          nwz=-1
        else
          call nprocinvalid()
        endif
      elseif ((nproc == 11) .or. (nproc == 16)) then
        kcase=kW_1jet
        nqcdjets=1
        ndim=7
        mb=0
        n2=0
        n3=1
        mass3=wmass
        width3=wwidth
        plabel(5)='pp'
        plabel(6)='pp'

        mcfmplotinfo= (/ 34, (0,j=1,49) /)
        
        if     (nproc == 11) then
C-- 11 '  f(p1)+f(p2) --> W^+(-->nu(p3)+e^+(p4))+f(p5)'
c--    '  f(p1)+f(p2) --> W^+ (no BR) + f(p5)' (removebr=.true.)
          nwz=1
          plabel(3)='nl'
          plabel(4)='ea'
        elseif (nproc == 16) then
c-- 16 '  f(p1)+f(p2) --> W^-(-->e^-(p3)+nu~(p4))+f(p5)'
c--    '  f(p1)+f(p2) --> W^- (no BR) + f(p5)' (removebr=.true.)
          nwz=-1
          plabel(3)='el'
          plabel(4)='na'
        endif

c--- simple hack for W-prime cross-section
        if (runstring(1:6) == 'wprime') then
          read(runstring(7:10),'(f4.1)') mass3
          mass3=mass3*1d3
          width3=wwidth*(mass3/wmass) ! scale W width linearly with W' mass
c--- width fit from Fig. 10 of Altarelli et al, Z. Phys. C45, 109 (1989)
          width3=4._dp+(mass3-100._dp)/30._dp
          wmass=mass3
          wwidth=width3
c--- sum over both W+ and W- 
          nwz=2
          write(6,*) '<<<<<< WARNING <<<<<'
          write(6,*) ' computing W-prime cross section'
          write(6,*) ' summed over both +ve and -ve charges'
          write(6,*) ' for W-prime of mass, width (GeV): ',wmass,wwidth
        endif
        
c--- total cross-section
        if (removebr) then
          call branch(brwen,brzee,brznn,brtau,brtop,brcharm)
          BrnRat=brwen
          plabel(3)='ig'
          plabel(4)='ig'
        endif
      endif

c--- set notag (may be modified by user, with care!)
      call setnotag()

c--- set up alpha-s again (in case nflav was changed)
      call coupling2

c--- remove 2 dimensions from integration if decay is not included
      if (nodecay) ndim=ndim-2

c--- report on the removed BR, if necessary
      if (removebr) then
       if (rank == 0) then
        write(6,*)'****************************************************'
       endif
       if (BrnRat .ne. 1._dp) then
        if (rank == 0) then
        write(6,*)'*             Setting zerowidth to .true.          *'
        endif
        zerowidth=.true.
       endif
       if (rank == 0) then
        write(6,98) BrnRat
        write(6,*)'****************************************************'
       endif
      endif
      
c--- if needed for photon proceses reset to 1/137.0
!      if(reset_alphaEM) call reset_aem(aem)
      if(reset_alphaEM) call reset_aem(1._dp/137.0_dp)

c--- initialize arrays that are used in is_functions
      call init_is_functions()

c--- fill up CKM matrix
      call ckmfill(nwz)

c--- set flags to true unless we're doing W+2 jet or Z+2 jet
      if ( ((kcase.ne.kW_2jet) .and. (kcase.ne.kZ_2jet))
     & .or. (kpart==klord) ) then
        Qflag=.true.
        Gflag=.true.
      endif

      return

 43   write(6,*) 'problems opening process.DAT'
      stop

 44   write(6,*) 'Unimplemented process number, nproc = ',nproc, 
     & ' mcfm halted'
      stop
 
 98   format(' *             Brn.Rat. removed = ',  f11.7, '       *')
 99   format(' * ',a82,' *')
     
      end

      subroutine nprocinvalid()
      implicit none
      include 'types.f'
      
      integer:: nproc
      common/nproc/nproc

      write(6,*) 'chooser: Unimplemented case'
      write(6,*) 'nproc=',nproc      
      stop
      
      return 
      end
      
      subroutine checkminzmass(i)
      implicit none
      include 'types.f'
      include 'constants.f'
c--- Checks that the minimum invariant mass specified in the options
c--- file is not zero for boson 34 (i=1) or boson 56 (i=2)
      
      include 'limits.f'
      include 'zerowidth.f'
      integer:: i

c--- if generating exactly on-shell, there's nothing to worry about
      if (zerowidth) return
      
      if ((i == 1) .and. (wsqmin == zip)) then
        write(6,*)
        write(6,*) 'Please set m34min not equal to zero to'
        write(6,*) 'prevent the virtual photon from becoming real.'
        stop
      endif

      if ((i == 2) .and. (bbsqmin == zip)) then
        write(6,*)
        write(6,*) 'Please set m56min not equal to zero to'
        write(6,*) 'prevent the virtual photon from becoming real.'
        stop
      endif
      
      return
      end
      
      
