      subroutine gen_lops(r,p,pswt,*)
      implicit none
      include 'types.f'
c--- calls appropriate subroutine to choose a 
c--- leading-order phase space point for the process
c--- specified by the variable 'case'   
c---
c---    input: vector of random numbers, r
c---    output: momenta p and phase-space weight pswt
c---    note: common block 'npart' is also filled here
c---    
c---    alternate return if generated point should be discarded
      
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'breit.f'
      include 'dm_params.f'
      include 'ipsgen.f'
      include 'limits.f'
      include 'masses.f'
!      include 'mxdim.f'
      include 'npart.f'
      include 'phasemin.f'
      include 'kprocess.f'
      include 'zerowidth.f'
      include 'energy.f'
      include 'new_pspace.f'
      include 'vegas_common.f'
      include 'taucut.f'
      include 'kpart.f'
      include 'hdecaymode.f'
      logical:: vetow_2gam
      integer:: ii
      real(dp):: r(mxdim),p(mxpart,4),pswt,
     & ptmp,m3,m4,m5,wt34,wt345,wt346,wt3456,wtprop,
     & s34,s345,s346,s3456,dot,wtips(4),plo(mxpart,4),pswtdip
      
c--- statement function
      wtprop(s34,wmass,wwidth)=(s34-wmass**2)**2+(wmass*wwidth)**2

      pswt=zip

c--- processes that use "gen2"
      if     ( (kcase==kW_only)
     &    .or. (kcase==kZ_only)
     &    .or. (kcase==kHigaga)
     &    .or. (kcase==kWcsbar)
     &    .or. (kcase==kWcs_ms)
     &    .or. (kcase==kvlchk2) ) then
        if (kcase==kvlchk2) then
          wsqmin=0._dp
          wsqmax=sqrts**2
        endif
        npart=2
c        if (new_pspace) then
c          call gen2a(r,p,pswt,*999)
c        else
          call gen2(r,p,pswt,*999)
c        endif

c--- processes that use "gen_njets" with an argument of "1"     
      elseif ( (kcase==kW_1jet)
     &    .or. (kcase==kWcjet0)
     &    .or. (kcase==kZ_1jet)
     &    .or. (kcase==kH_1jet)
     &    .or. (kcase==khttjet)
     &    .or. (kcase==kattjet)
     &    .or. (kcase==kggfus1)
     &    .or. (kcase==kHgagaj)
     &    .or. (kcase==kgQ__ZQ) ) then
        npart=3
        if     ((usescet) .and. (abovecut) .and. (kpart.ne.kreal)) then
c           call gen3taucut(r,p,pswt,*999)
           call gen3(r,p,pswt,*999)
        elseif ((usescet) .and. (abovecut) .and. (kpart == kreal)) then
            call gen3(r,p,pswt,*999)
         else
            call gen_njets(r,1,p,pswt,*999)
c            call gen3(r,p,pswt,*999)
        endif
         
c--- processes that use "gen_njets" with an argument of "2"
      elseif ( (kcase==kWbbbar)
     &    .or. (kcase==kW_2jet)
     &    .or. (kcase==kZ_2jet)
     &    .or. (kcase==kZbbbar)
     &    .or. (kcase==kqq_Hqq)
     &    .or. (kcase==kqq_Hgg)
     &    .or. (kcase==kggfus2)
     &    .or. (kcase==kgagajj)
     &    .or. (kcase==kW_bjet)
     &    .or. (kcase==kWcjetg)
     &    .or. (kcase==kZ_bjet) ) then
        npart=4
        if ((usescet) .and. (abovecut)) then
c          call genVjtaucut(r,p,pswt,*999)
          call gen_njets(r,2,p,pswt,*999)
        else
          call gen_njets(r,2,p,pswt,*999)
        endif
      else
        if ((kcase==kvlchk4) .or. (kcase==kvlchkm)) then
          wsqmin=0._dp
          wsqmax=sqrts**2
        endif
        npart=4
        call gen4(r,p,pswt,*999)
      endif

c--- ensure no entry beyond npart+2
      p(npart+3,:)=0._dp
      
      return

c--- alternate return
  999 continue 
      pswt=zip
      return 1
      
      end
      
