      function lowint(r,wgt)
      implicit none
      include 'types.f'
      real(dp):: lowint
      include 'polarized.f' 
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'masses.f'
      include 'limits.f'
      include 'npart.f'
      include 'debug.f'
      include 'new_pspace.f'
      include 'vegas_common.f'
      include 'sprods_com.f'
      include 'scale.f'
      include 'facscale.f'
      include 'dynamicscale.f'
      include 'noglue.f'
      include 'kprocess.f'
      include 'efficiency.f'
      include 'maxwt.f'
      include 'phasemin.f'
      include 'PDFerrors.f'
      include 'wts_bypart.f'
      include 'stopscales.f'
      include 'frag.f'
      include 'ipsgen.f'
      include 'outputoptions.f'
      include 'outputflags.f'
      include 'runstring.f'
      include 'energy.f'
      include 'VVstrong.f'
      include 'dm_params.f'
      include 'initialscales.f'
      include 'toploopgaga.f'
c---- SSbegin
      include 'reweight.f'
c---- SSend
c --- DSW. To store flavour information :
      include 'nflav.f'
c --- DSW.
      include 'x1x2.f'
      include 'bypart.f'
      integer:: pflav,pbarflav
c--- To use VEGAS random number sequence :
      real(dp):: ran2
      integer:: ih1,ih2,j,k,nvec,sgnj,sgnk,ii,i1,i2,i3,i4
      integer:: i,t
      real(dp):: r(mxdim),W,xmsq,val,val2,ptmp,
     & fx1(-nf:nf),fx2(-nf:nf),p(mxpart,4),pjet(mxpart,4),
     & pswt,rscalestart,fscalestart,
     & fx1_H(-nf:nf),fx2_H(-nf:nf),fx1_L(-nf:nf),fx2_L(-nf:nf),
     & fxb1(-nf:nf),fxb2(-nf:nf),xmsq_array(-nf:nf,-nf:nf)
      real(dp):: pfx1(-nf:nf,-1:1)
      real(dp):: pfx2(-nf:nf,-1:1)
      real(dp):: wgt,msq(-nf:nf,-nf:nf),m3,m4,m5,xmsqjk
      real(dp):: msq1(-nf:nf,-nf:nf),
     & msq4(-nf:nf,-nf:nf,-nf:nf,-nf:nf),
     & msqpol(-nf:nf,-nf:nf,-1:1,-1:1)
      real(dp):: flux,vol,vol_mass,vol3_mass,vol_wt,BrnRat
      real(dp):: xmsq_bypart(-1:1,-1:1)
      logical:: bin,includedipole,checkpiDpjk
      real(dp):: b1scale,q2scale,q1scale,b2scale
      external qg_tbq,BSYqqb_QQbdk_gvec,qqb_QQbdk,qg_tbqdk,qg_tbqdk_gvec,
     & qqb_Waa,qqb_Waa_mad
     & qqb_Zbbmas,qqb_Zbbmas,qqb_totttZ,qqb_totttZ_mad
      common/density/ih1,ih2
      common/bin/bin
      common/BrnRat/BrnRat
      common/bqscale/b1scale,q2scale,q1scale,b2scale
      external qq_tchan_ztq,qq_tchan_ztq_mad
      external qq_tchan_htq,qq_tchan_htq_mad,qq_tchan_htq_amp
      external qqb_gamgam_g,qqb_gmgmjt_gvec
!$omp threadprivate(/bqscale/)

!$omp atomic
      ntotshot=ntotshot+1
      lowint=0._dp
c--- ensure isolation code does not think this is fragmentation piece
      z_frag=0._dp
      
      W=sqrts**2
      p(:,:)=0._dp

      call gen_lops(r,p,pswt,*999)

      nvec=npart+2
      call dotem(nvec,p,s)
      
      if(pol1.eq.0 .and. pol2.eq.0) then
      elseif(pol1.eq.1 .and.pol2.eq.0) then
      else
          print *, "  ipol1 = ", pol1, "   ipol2 = ", pol2
          print *, "  not implemented "
          stop
      endif

c--- (moved to includedipole) impose cuts on final state
c      if (kcase.ne.kvlchk6 .and. kcase.ne.ktautau) then
c        call masscuts(p,*999)
c      endif

c---- reject event if any s(i,j) is too small
c      call smalls(s,npart,*999)
c----reject event if any tau is too small
      call smalltau(p,npart,*999)
c--- see whether this point will pass cuts - if it will not, do not
c--- bother calculating the matrix elements for it, instead bail out
      if (includedipole(0,p) .eqv. .false.) then
        goto 999
      endif

c      call writeout(p)
c      stop
      if (dynamicscale) call scaleset(initscale,initfacscale,p)
      
      xx(1)=-2._dp*p(1,4)/sqrts
      xx(2)=-2._dp*p(2,4)/sqrts

c      if (debug) write(*,*) 'Reconstructed x1,x2 ',xx(1),xx(2)

c--- Calculate the required matrix elements      
      if     (kcase==kW_only) then
        
        if(pol1.eq.0) call qqb_w(p,msq)
        if(pol1.eq.1) call Delta_qqb_w(p,msq)
      elseif (kcase==kW_1jet) then
        if(pol1.eq.0) call qqb_w_g(p,msq)
        if(pol1.eq.1) call Delta_qqb_w_g(p,msq)
      endif
      
      
      do j=-1,1
      do k=-1,1
      xmsq_bypart(j,k)=0._dp
      enddo
      enddo 

      currentPDF=0

c--- do not calculate the flux if we're only checking the volume      
c      if (case(1:4) .ne. 'vlch') then      
      flux=fbGeV2/(2._dp*xx(1)*xx(2)*W)
c      endif
      
c--- initialize a PDF set here, if calculating errors
  777 continue    
      xmsq=0._dp

c--- calculate PDF's  
          if(pol1 .eq. 0 ) then
              call fdist(ih1,xx(1),facscale,fx1)
          else
              call fdist1(ih1,xx(1),facscale,fx1)
          endif
          call fdist(ih2,xx(2),facscale,fx2)

          do j=-nflav,nflav
          do k=-nflav,nflav    
          
          if (ggonly) then
          if ((j.ne.0) .or. (k.ne.0)) goto 20
          endif

          if (gqonly) then
          if (((j==0).and.(k==0)) .or. ((j.ne.0).and.(k.ne.0))) goto 20
          endif
          
          if (noglue) then 
          if ((j==0) .or. (k==0)) goto 20
          endif

          if (omitgg) then 
          if ((j==0) .and. (k==0)) goto 20
          endif
            xmsqjk=fx1(j)*fx2(k)*msq(j,k)

          xmsq=xmsq+xmsqjk
          xmsq_array(j,k)=xmsqjk
          
          if     (j > 0) then
            sgnj=+1
          elseif (j < 0) then
            sgnj=-1
          else
            sgnj=0
          endif
          if     (k > 0) then
            sgnk=+1
          elseif (k < 0) then
            sgnk=-1
          else
            sgnk=0
          endif

          if (currentPDF == 0) then
            xmsq_bypart(sgnj,sgnk)=xmsq_bypart(sgnj,sgnk)+xmsqjk
          endif
          
 20       continue
          enddo
          enddo

      if (currentPDF == 0) then
        lowint=flux*pswt*xmsq/BrnRat
      endif
            
c--- loop over all PDF error sets, if necessary
      if (PDFerrors) then
        PDFwgt(currentPDF)=flux*pswt*xmsq/BrnRat*wgt/itmx
!$omp atomic
        PDFxsec(currentPDF)=PDFxsec(currentPDF)
     &     +PDFwgt(currentPDF)
        currentPDF=currentPDF+1
        if (currentPDF <= maxPDFsets) goto 777
      endif    

        wt_gg=xmsq_bypart(0,0)*wgt*flux*pswt/BrnRat/real(itmx,dp)
        wt_gq=(xmsq_bypart(+1,0)+xmsq_bypart(-1,0)
     &        +xmsq_bypart(0,+1)+xmsq_bypart(0,-1)
     &        )*wgt*flux*pswt/BrnRat/real(itmx,dp)
        wt_qq=(xmsq_bypart(+1,+1)+xmsq_bypart(-1,-1)
     &        )*wgt*flux*pswt/BrnRat/real(itmx,dp)
        wt_qqb=(xmsq_bypart(+1,-1)+xmsq_bypart(-1,+1)
     &        )*wgt*flux*pswt/BrnRat/real(itmx,dp)

      call getptildejet(0,pjet)
      
      call dotem(nvec,pjet,s)

      val=wgt*flux*pswt/BrnRat
      do j=-1,1
         do k=-1,1
!$omp atomic            
        lord_bypart(j,k)=lord_bypart(j,k)+
     &       val*xmsq_bypart(j,k)
      enddo
      enddo


      
      val=lowint*wgt
      val2=val**2
      if(val.ne.val) then
         write(6,*) 'lowint val = ',val
         write(6,*) 'Discarding point with random variables',r
         lowint=zip
         val=zip
         goto 999
      endif
c---  SSbegin
      lowint = lowint*reweight
c---  SSend
c--- update the maximum weight so far, if necessary
c---  but not if we are already unweighting ...
      if ((.not.unweight) .and. (abs(val) > wtmax)) then
!$omp critical(MaxWgt)
        wtmax=abs(val)
!$omp end critical(MaxWgt)
      endif


      if (bin) then
         call nplotter(pjet,val,val2,0)
c---  POWHEG-style output if requested
      endif

c --- Check weights :
      if (unweight) then
c       write(6,*) 'Test weight ',val,' against max ',wtmax
        wtabs = abs(val)
c--- note that r(ndim+2) is reserved for new_pspace in real, so unused at LO
        if (r(ndim+2) < (wtabs/wtmax)) then
c         write(6,*) 'Keep event with weight',val
          if (wtabs<wtmax) then
            newwt = 1._dp
          else
            newwt = wtabs/wtmax
          endif
          if (newwt > 1.0_dp) then
            write(6,*) 'WARNING : lowint : event with |weight| > 1.',
     &                 ' |weight| = ',newwt
          endif
c ---     just in case the weight was negative :
          newwt = newwt*sign(one,val)
c         call nplotter(pjet,newwt,newwt,0)
!$omp critical(LowintWriteLHE)
          call mcfm_writelhe(pjet,xmsq_array,newwt)
!$omp end critical(LowintWriteLHE)
        endif
      endif

      return

 999  continue
      lowint=0._dp
!$omp atomic
      ntotzero=ntotzero+1
      
      return
      end


