      function virtint(r,wgt)
      implicit none
      include 'types.f'
      real(dp):: virtint
      
      include 'polarized.f' 
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'noglue.f'
      include 'vegas_common.f'
      include 'sprods_com.f'
      include 'npart.f'
      include 'epinv.f'
      include 'epinv2.f'
      include 'agq.f'
      include 'PR_new.f'
      include 'PR_cs_new.f'
      include 'PR_h2j.f'
      include 'PR_twojet.f'
      include 'PR_stop.f'
      include 'msq_cs.f'
      include 'msq_struc.f'
      include 'qcdcouple.f'
      include 'scale.f'
      include 'facscale.f'
      include 'dynamicscale.f'
      include 'efficiency.f'
      include 'lc.f'
      include 'kprocess.f'
      include 'maxwt.f'
      include 'limits.f'
      include 'heavyflav.f'
      include 'nflav.f'
      include 'b0.f'
      include 'PDFerrors.f'
      include 'masses.f'
      include 'wts_bypart.f'
      include 'nores.f'
      include 'stopscales.f'
      include 'stopbmass.f'
      include 'ewcouple.f'
      include 'flags.f'
      include 'frag.f'
      include 'ipsgen.f'
      include 'phasemin.f'
      include 'outputoptions.f'
      include 'outputflags.f'
      include 'TRbadpoint.f'
      include 'dm_params.f'
      include 'runstring.f' 
      include 'x1x2.f'
      include 'bypart.f'
      include 'energy.f'
      include 'first.f'
      include 'initialscales.f'
      include 'taucut.f'
      include 'ppmax.f'
      include 'kpart.f'
      include 'hbbparams.f'
      include 'mpicommon.f'
c--- APPLgrid - grid includes
c      include 'ptilde.f'
c      include 'APPLinclude.f'
c      real(dp):: f_X1overZ, f_X2overZ, psCR, psCR0
c--- APPLgrid - end 

      real(dp):: mqq(0:2,-nf:nf,-nf:nf),
     & msqx(0:2,-nf:nf,-nf:nf,-nf:nf,-nf:nf)
      real(dp):: ppmsqx(0:2,ppmax)
      real(dp):: msqx_cs(0:2,-nf:nf,-nf:nf)
      real(dp):: AP(-1:1,-1:1,3),APqg_mass
      real(dp):: DAP(-1:1,-1:1,3)

c---- SSbegin
      include 'reweight.f'
      logical:: purevirt
      common/useropt/purevirt
      data purevirt/.false./
c---- SSend 

      integer:: ih1,ih2,j,k,m,n,cs,ics,csmax,nvec,is,iq,ia,ib,ic,ii
      real(dp):: p(mxpart,4),pjet(mxpart,4),r(mxdim),W,xmsq,
     & val,val2,fx1(-nf:nf),fx2(-nf:nf),fx1z(-nf:nf),fx2z(-nf:nf),xmsqt,
     & fx1_H(-nf:nf),fx2_H(-nf:nf),fx1_L(-nf:nf),fx2_L(-nf:nf),
     & fx1z_H(-nf:nf),fx2z_H(-nf:nf),fx1z_L(-nf:nf),fx2z_L(-nf:nf)
      real(dp):: pswt,xjac,m3,m4,m5,
     & wgt,msq(-nf:nf,-nf:nf),msqv(-nf:nf,-nf:nf),msqvdk(-nf:nf,-nf:nf),
     & msqvdkW(-nf:nf,-nf:nf),
     & msq_qq,msq_aa,msq_aq,msq_qa,msq_qg,msq_gq,epcorr
      real(dp):: z,x1onz,x2onz,flux,omz,
     & BrnRat,xmsq_old,tmp,ptmp,pttwo
      real(dp):: xmsq_bypart(-1:1,-1:1)
      integer:: nshot,rvcolourchoice,sgnj,sgnk
      logical:: bin,includedipole,checkpiDpjk
      real(dp):: QandGint
      integer mykpart

      integer:: t

      common/density/ih1,ih2
      common/bin/bin
      common/BrnRat/BrnRat
      common/rvcolourchoice/rvcolourchoice
      common/mykpart/mykpart
c      common/ggZZunstable/ggZZunstable
c      data p/56*0._dp/
      data nshot/1/
      save nshot
      external gg_ZZ,qqb_w1jet_vbis
!$omp threadprivate(/rvcolourchoice/)
!$omp threadprivate(nshot,/useropt/)

      QandGflag=.false.
      if (first) then
         first=.false.
!         write(*,*) case
         nshot=1
      endif

!$omp atomic
      ntotshot=ntotshot+1
      virtint=0._dp
c--- ensure isolation code does not think this is fragmentation piece
      z_frag=0._dp

      W=sqrts**2

      call gen_lops(r,p,pswt,*999)
      
      nvec=npart+2
      call dotem(nvec,p,s)

c--- (moved to includedipole) impose cuts on final state
c      call masscuts(p,*999)

c----reject event if any s(i,j) is too small
c      call smalls(s,npart,*999)
c----reject event if any tau is too small
      call smalltau(p,npart,*999)
         
c--- see whether this point will pass cuts - if it will not, do not
c--- bother calculating the matrix elements for it, instead bail out
      if (includedipole(0,p) .eqv. .false.) then
        goto 999
      endif
      
      if (dynamicscale) call scaleset(initscale,initfacscale,p)
     
      xx(1)=-2._dp*p(1,4)/sqrts
      xx(2)=-2._dp*p(2,4)/sqrts

      z=r(ndim)**2
c      if (nshot == 1) z=0.95_dp
      xjac=two*sqrt(z)
      
      omz=1._dp-z

      flux=fbGeV2/(2._dp*xx(1)*xx(2)*W)

c--- to test poles, we need colourchoice=0, but save real value
      if (nshot == 1) then
        rvcolourchoice=colourchoice
        colourchoice=0
      endif
      
   12 continue
c--- point to restart from when checking epsilon poles

c--- correction to epinv from AP subtraction when mu_FAC != mu_REN,
c--- corresponding to subtracting -1/epinv*Pab*log(musq_REN/musq_FAC)
      epcorr=epinv+2._dp*log(scale/facscale)
      
      AP(q,q,1)=+ason2pi*Cf*1.5_dp*epcorr
      AP(q,q,2)=+ason2pi*Cf*(-1._dp-z)*epcorr
      AP(q,q,3)=+ason2pi*Cf*2._dp/omz*epcorr
      AP(a,a,1)=+ason2pi*Cf*1.5_dp*epcorr
      AP(a,a,2)=+ason2pi*Cf*(-1._dp-z)*epcorr
      AP(a,a,3)=+ason2pi*Cf*2._dp/omz*epcorr

      AP(q,g,1)=0._dp
      AP(q,g,2)=ason2pi*Tr*(z**2+omz**2)*epcorr
      AP(q,g,3)=0._dp
      AP(a,g,1)=0._dp
      AP(a,g,2)=ason2pi*Tr*(z**2+omz**2)*epcorr
      AP(a,g,3)=0._dp

      AP(g,q,1)=0._dp
      AP(g,q,2)=ason2pi*Cf*(1._dp+omz**2)/z*epcorr
      AP(g,q,3)=0._dp
      AP(g,a,1)=0._dp
      AP(g,a,2)=ason2pi*Cf*(1._dp+omz**2)/z*epcorr
      AP(g,a,3)=0._dp

      AP(g,g,1)=+ason2pi*b0*epcorr
      AP(g,g,2)=+ason2pi*xn*2._dp*(1._dp/z+z*omz-2._dp)*epcorr
      AP(g,g,3)=+ason2pi*xn*2._dp/omz*epcorr

      ! delta AP
      ! for polarized beam (+)-(-)
      ! note that q->q is not changed 
      ! for q->q we will use AP
      DAP = 0._dp
      DAP(q,q,1)=+ason2pi*Cf*1.5_dp*epcorr
      DAP(q,q,2)=+ason2pi*Cf*(-1._dp-z)*epcorr
      DAP(q,q,3)=+ason2pi*Cf*2._dp/omz*epcorr
      DAP(a,a,1)=+ason2pi*Cf*1.5_dp*epcorr
      DAP(a,a,2)=+ason2pi*Cf*(-1._dp-z)*epcorr
      DAP(a,a,3)=+ason2pi*Cf*2._dp/omz*epcorr
      
      DAP(q,g,1)=0._dp
      DAP(q,g,2)=ason2pi*Tr*(2._dp*z-1._dp)*epcorr
      DAP(q,g,3)=0._dp
      DAP(a,g,1)=0._dp
      DAP(a,g,2)=ason2pi*Tr*(2._dp*z-1._dp)*epcorr
      DAP(a,g,3)=0._dp

      DAP(g,q,1)=0._dp
      DAP(g,q,2)=ason2pi*Cf*(2._dp-z)*epcorr
      DAP(g,q,3)=0._dp
      DAP(g,a,1)=0._dp
      DAP(g,a,2)=ason2pi*Cf*(2._dp-z)*epcorr
      DAP(g,a,3)=0._dp

      DAP(g,g,1)=+ason2pi*b0*epcorr
      DAP(g,g,2)=+ason2pi*xn*2._dp*(1._dp-2._dp*z)*epcorr
      DAP(g,g,3)=+ason2pi*xn*2._dp/omz*epcorr

      ! unpolarized case, DAP=AP
      if(pol1.eq.0) DAP = AP

      do ia=-1,+1
      do ib=-1,+1
      do ic=-1,+1
      do is=1,3
        Q1(ia,ib,ic,is)=0._dp
        Q2(ia,ib,ic,is)=0._dp
      do cs=1,8
        H1(ia,ib,ic,cs,is)=0._dp
        H2(ia,ib,ic,cs,is)=0._dp
      enddo
      do cs=0,2
        R1(ia,ib,ic,cs,is)=0._dp
        R2(ia,ib,ic,cs,is)=0._dp
      do j=1,8
        S1(ia,ib,ic,j,cs,is)=0._dp
        S2(ia,ib,ic,j,cs,is)=0._dp
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      
c--- test to see whether we need Gflag and Qflag together
      if ( ((kcase==kW_2jet) .or. (kcase==kZ_2jet))
     &.and. (Qflag) .and. (Gflag) ) then
        QandGflag=.true.
        QandGint=0._dp
c--- first pass: Gflag
        Gflag=.true.
        Qflag=.false.
      endif
      
c--- restart from here when calculating with Qflag and Gflag
c--- (W+2 jet and Z+2 jet processes only)
   44 continue      
      
c--- Calculate the required matrix elements
      if     (kcase==kW_only) then
          if(pol1.eq.0) then
            call qqb_w(p,msq)
            call qqb_w_v(p,msqv)
          elseif(pol1.eq.1) then
            call delta_qqb_w(p,msq)
            call delta_qqb_w_v(p,msqv)
          endif
          call qqb_w_z(p,z)

      elseif (kcase==kW_1jet) then
          if(pol1.eq.0) then
             call qqb_w_g(p,msq)
             call qqb_w1jet_v(p,msqv)
             call qqb_w1jet_z(p,z)
          elseif(pol1.eq.1) then
             call delta_qqb_w_g(p,msq)
             call delta_qqb_w1jet_v(p,msqv)
             call delta_qqb_w1jet_z(p,z)
          endif
      endif
      
c--- explicitly remove factor of LO if we are only interested in coefficient
      if (coeffonly) then
        msqv(:,:)=msqv(:,:)-msq(:,:)
      endif

C---initialize to zero
      do j=-1,1
      do k=-1,1
      xmsq_bypart(j,k)=0._dp
      enddo
      enddo

      currentPDF=0
            
c--- initialize a PDF set here, if calculating errors
  777 continue
      xmsq=0._dp
         call fdist1(ih1,xx(1),facscale,fx1)
         call fdist(ih2,xx(2),facscale,fx2)
      
      do j=-nf,nf
      fx1z(j)=0._dp
      fx2z(j)=0._dp
      enddo
            
      if (z > xx(1)) then
        x1onz=xx(1)/z
              call fdist1(ih1,x1onz,facscale,fx1z)
      endif
      if (z > xx(2)) then
        x2onz=xx(2)/z
              call fdist(ih2,x2onz,facscale,fx2z)
      endif         
      
      do j=-nflav,nflav
      do k=-nflav,nflav
  
      if (ggonly) then
      if ((j.ne.0) .or. (k.ne.0)) goto 20
      endif

      if (gqonly) then
      if (((j==0).and.(k==0)) .or. ((j.ne.0).and.(k.ne.0))) goto 20
      endif      
      
      if (noglue) then 
      if ((j==0) .or. (k==0)) goto 20
      endif

      if (omitgg) then 
      if ((j==0) .and. (k==0)) goto 20
      endif

      if ((kcase==kWcsbar).and.(j .ne. 4).and.(k .ne. 4)) goto 20

      tmp=xmsq

c--- The variables R1 and R2 provide the Regular and Plus pieces associated
c--- with radiation from leg 1 (R1(a,b,c,cs,is)) and leg 2 (R2(a,b,c,cs,is))
c--- In each case the parton labelling is using the normal QM notation of 
c--- putting everything backward
c---       emitted line after emission =    a
c---       emitter before emission     =    b
c---       spectator                   =    c
c--- There is no label for he or she who is emitted.
c--- Note that in general each piece will be composed of many different
c--- dipole contributions

c--- SUM BY COLOUR STRUCTURES: H+2jets only
      if  ( (kcase==kggfus2) 
     & .or. (kcase==kgagajj)
     & .or. (kcase==kHWW2jt)
     & .or. (kcase==kHZZ2jt)) then
      
      elseif (kcase==ktwojet)then
      elseif ((kcase==kW_2jet) .or. (kcase==kZ_2jet)
     &   .or. (kcase==kW_bjet) .or. (kcase==kZ_bjet)
     &   .or. (kcase==ktt_bbl) .or. (kcase==ktt_bbh)
     &   .or. (kcase==ktt_bbu)
     &   .or. (kcase==ktt_tot) .or. (kcase==kbb_tot)
     &   .or. (kcase==kcc_tot)) then

      elseif ((kcase==kqg_tbq) .or. (kcase==k4ftwdk)
     &    .or.(kcase==kdk_4ft)) then

      else

C--QQ
      if     ((j > 0) .and. (k>0)) then
      xmsq=xmsq+(msqv(j,k)
     & + msq(j,k)*(one+DAP(q,q,1)-DAP(q,q,3)+Q1(q,q,q,1)-Q1(q,q,q,3)
     &                +AP(q,q,1)-AP(q,q,3)+Q2(q,q,q,1)-Q2(q,q,q,3)))
     &                *fx1(j)*fx2(k)
     & +(msq(j,k)*(DAP(q,q,2)+DAP(q,q,3)+Q1(q,q,q,2)+Q1(q,q,q,3))
     & + msq(g,k)*(DAP(g,q,2)+Q1(g,q,q,2)))*fx1z(j)/z*fx2(k)
     & +(msq(j,k)*(AP(q,q,2)+AP(q,q,3)+Q2(q,q,q,2)+Q2(q,q,q,3))
     & + msq(j,g)*(AP(g,q,2)+Q2(g,q,q,2)))*fx1(j)*fx2z(k)/z

C--QbarQbar
      elseif ((j < 0) .and. (k<0)) then
      xmsq=xmsq+(msqv(j,k)
     & + msq(j,k)*(one+DAP(a,a,1)-DAP(a,a,3)+Q1(a,a,a,1)-Q1(a,a,a,3)
     &                +AP(a,a,1)-AP(a,a,3)+Q2(a,a,a,1)-Q2(a,a,a,3)))
     &                *fx1(j)*fx2(k)
     & +(msq(j,k)*(DAP(a,a,2)+DAP(a,a,3)+Q1(a,a,a,2)+Q1(a,a,a,3))
     & + msq(g,k)*(DAP(g,a,2)+Q1(g,a,a,2)))*fx1z(j)/z*fx2(k)
     & +(msq(j,k)*(AP(a,a,2)+AP(a,a,3)+Q2(a,a,a,2)+Q2(a,a,a,3))
     & + msq(j,g)*(AP(g,a,2)+Q2(g,a,a,2)))*fx1(j)*fx2z(k)/z

C--QQbar
      elseif ((j > 0) .and. (k<0)) then
      xmsq=xmsq+(msqv(j,k)
     & + msq(j,k)*(one+DAP(q,q,1)-DAP(q,q,3)+Q1(q,q,a,1)-Q1(q,q,a,3)
     &                +AP(a,a,1)-AP(a,a,3)+Q2(a,a,q,1)-Q2(a,a,q,3)))
     &                *fx1(j)*fx2(k)
     & +(msq(j,k)*(DAP(q,q,2)+DAP(q,q,3)+Q1(q,q,a,3)+Q1(q,q,a,2))
     & + msq(g,k)*(DAP(g,q,2)+Q1(g,q,a,2)))*fx1z(j)/z*fx2(k)
     & +(msq(j,k)*(AP(a,a,2)+AP(a,a,3)+Q2(a,a,q,3)+Q2(a,a,q,2))
     & + msq(j,g)*(AP(g,a,2)+Q2(g,a,q,2)))*fx1(j)*fx2z(k)/z

      elseif ((j < 0) .and. (k>0)) then
C--QbarQ
      xmsq=xmsq+(msqv(j,k)
     & +msq(j,k)*(one+DAP(a,a,1)-DAP(a,a,3)+Q1(a,a,q,1)-Q1(a,a,q,3)
     &               +AP(q,q,1)-AP(q,q,3)+Q2(q,q,a,1)-Q2(q,q,a,3)))
     &               *fx1(j)*fx2(k)
     & +(msq(j,k)*(DAP(a,a,3)+DAP(a,a,2)+Q1(a,a,q,3)+Q1(a,a,q,2))
     & + msq(g,k)*(DAP(g,a,2)+Q1(g,a,q,2)))*fx1z(j)/z*fx2(k)
     & +(msq(j,k)*(AP(q,q,3)+AP(q,q,2)+Q2(q,q,a,3)+Q2(q,q,a,2))
     & + msq(j,g)*(AP(g,q,2)+Q2(g,q,a,2)))*fx1(j)*fx2z(k)/z

      elseif ((j == g) .and. (k==g)) then
C--gg
       msq_qg=msq(+5,g)+msq(+4,g)+msq(+3,g)+msq(+2,g)+msq(+1,g)
     &       +msq(-5,g)+msq(-4,g)+msq(-3,g)+msq(-2,g)+msq(-1,g)
       msq_gq=msq(g,+5)+msq(g,+4)+msq(g,+3)+msq(g,+2)+msq(g,+1)
     &       +msq(g,-5)+msq(g,-4)+msq(g,-3)+msq(g,-2)+msq(g,-1)
       xmsq=xmsq+(msqv(g,g)
     &  +msq(g,g)*(one+DAP(g,g,1)-DAP(g,g,3)+Q1(g,g,g,1)-Q1(g,g,g,3)
     &                +AP(g,g,1)-AP(g,g,3)+Q2(g,g,g,1)-Q2(g,g,g,3)))
     &                *fx1(g)*fx2(g)
     &  +(msq(g,g)*(DAP(g,g,2)+DAP(g,g,3)+Q1(g,g,g,2)+Q1(g,g,g,3))
     &  +   msq_qg*(DAP(q,g,2)+Q1(q,g,g,2)))*fx1z(g)/z*fx2(g)
     &  +(msq(g,g)*(AP(g,g,2)+AP(g,g,3)+Q2(g,g,g,2)+Q2(g,g,g,3))
     &  +   msq_gq*(AP(q,g,2)+Q2(q,g,g,2)))*fx1(g)*fx2z(g)/z

      elseif (j == g) then
C--gQ
       if    (k > 0) then
       msq_aq=msq(-1,k)+msq(-2,k)+msq(-3,k)+msq(-4,k)+msq(-5,k)
       msq_qq=msq(+1,k)+msq(+2,k)+msq(+3,k)+msq(+4,k)+msq(+5,k)
       xmsq=xmsq+(msqv(g,k)
     & +msq(g,k)*(one+DAP(g,g,1)-DAP(g,g,3)+Q1(g,g,q,1)-Q1(g,g,q,3)
     &               +AP(q,q,1)-AP(q,q,3)+Q2(q,q,g,1)-Q2(q,q,g,3)))
     &               *fx1(g)*fx2(k)
     & +(msq(g,k)*(DAP(g,g,2)+DAP(g,g,3)+Q1(g,g,q,2)+Q1(g,g,q,3))
     & +   msq_aq*(DAP(a,g,2)+Q1(a,g,q,2))
     & +   msq_qq*(DAP(q,g,2)+Q1(q,g,q,2)))*fx1z(g)/z*fx2(k)
     & +(msq(g,k)*(AP(q,q,2)+AP(q,q,3)+Q2(q,q,g,2)+Q2(q,q,g,3))
     & + msq(g,g)*(AP(g,q,2)+Q2(g,q,g,2)))*fx1(g)*fx2z(k)/z

C--gQbar
       elseif (k<0) then
       msq_qa=msq(+1,k)+msq(+2,k)+msq(+3,k)+msq(+4,k)+msq(+5,k)
       msq_aa=msq(-1,k)+msq(-2,k)+msq(-3,k)+msq(-4,k)+msq(-5,k)
       xmsq=xmsq+(msqv(g,k)
     & +msq(g,k)*(one+DAP(g,g,1)-DAP(g,g,3)+Q1(g,g,a,1)-Q1(g,g,a,3)
     &               +AP(a,a,1)-AP(a,a,3)+Q2(a,a,g,1)-Q2(a,a,g,3)))
     &               *fx1(g)*fx2(k)
     & +(msq(g,k)*(DAP(g,g,2)+DAP(g,g,3)+Q1(g,g,a,2)+Q1(g,g,a,3))
     & +   msq_qa*(DAP(q,g,2)+Q1(q,g,a,2))
     & +   msq_aa*(DAP(a,g,2)+Q1(a,g,a,2)))*fx1z(g)/z*fx2(k)
     & +(msq(g,k)*(AP(a,a,2)+AP(a,a,3)+Q2(a,a,g,2)+Q2(a,a,g,3))
     & + msq(g,g)*(AP(g,a,2)+Q2(g,a,g,2)))*fx1(g)*fx2z(k)/z

       endif
C--Qg
      elseif (k == g) then
       if     (j>0) then
       msq_qa=msq(j,-1)+msq(j,-2)+msq(j,-3)+msq(j,-4)+msq(j,-5)
       msq_qq=msq(j,+1)+msq(j,+2)+msq(j,+3)+msq(j,+4)+msq(j,+5)
       xmsq=xmsq+(msqv(j,g)
     & +msq(j,g)*(one
     &               +DAP(q,q,1)-DAP(q,q,3)+Q1(q,q,g,1)-Q1(q,q,g,3)
     &               +AP(g,g,1)-AP(g,g,3)+Q2(g,g,q,1)-Q2(g,g,q,3)))
     &               *fx1(j)*fx2(g)
     & +(msq(j,g)*(DAP(q,q,2)+DAP(q,q,3)+Q1(q,q,g,2)+Q1(q,q,g,3))
     & + msq(g,g)*(DAP(g,q,2)+Q1(g,q,g,2)))*fx1z(j)/z*fx2(g)
     & +(msq(j,g)*(AP(g,g,2)+AP(g,g,3)+Q2(g,g,q,2)+Q2(g,g,q,3))
     & +   msq_qa*(AP(a,g,2)+Q2(a,g,q,2))
     & +   msq_qq*(AP(q,g,2)+Q2(q,g,q,2)))*fx1(j)*fx2z(g)/z

C--Qbarg
       elseif (j<0) then
       msq_aq=msq(j,+1)+msq(j,+2)+msq(j,+3)+msq(j,+4)+msq(j,+5)
       msq_aa=msq(j,-1)+msq(j,-2)+msq(j,-3)+msq(j,-4)+msq(j,-5)
       xmsq=xmsq+(msqv(j,g)
     & +msq(j,g)*(one+DAP(a,a,1)-DAP(a,a,3)+Q1(a,a,g,1)-Q1(a,a,g,3)
     &               +AP(g,g,1)-AP(g,g,3)+Q2(g,g,a,1)-Q2(g,g,a,3)))
     &                *fx1(j)*fx2(g)
     & +(msq(j,g)*(DAP(a,a,2)+DAP(a,a,3)+Q1(a,a,g,2)+Q1(a,a,g,3))
     & + msq(g,g)*(DAP(g,a,2)+Q1(g,a,g,2)))*fx1z(j)/z*fx2(g)
     & +(msq(j,g)*(AP(g,g,2)+AP(g,g,3)+Q2(g,g,a,3)+Q2(g,g,a,2))
     & + msq_aq*(AP(q,g,2)+Q2(q,g,a,2))
     & + msq_aa*(AP(a,g,2)+Q2(a,g,a,2)))*fx1(j)*fx2z(g)/z

       endif
      endif
      
c      if (xmsq-tmp .ne. 0._dp) write(6,*) j,k,'-> msqc = ',xmsq-tmp

      endif

c--- subtract off LO (we don't want it) for Wcs_ms case and for
c--- the comparison with C. Oleari's e+e- --> QQbg calculation
c      if ((kcase==kWcs_ms) .or. (runstring(1:5) == 'carlo')) then
c--- (MCFM_original)  if (kcase==kWcs_ms) then                                                                                          
c---  SSbegin                                                                                                                      
      if ((kcase==kWcs_ms) .or. (purevirt)) then
c---  SSend                                                                                                                        
        xmsq=xmsq-msq(j,k)*fx1(j)*fx2(k)
      endif  
           
      if     (j > 0) then
        sgnj=+1
      elseif (j < 0) then
        sgnj=-1
      else
        sgnj=0
      endif
      if     (k > 0) then
        sgnk=+1
      elseif (k < 0) then
        sgnk=-1
      else
        sgnk=0
      endif

      if (currentPDF == 0) then
        xmsq_bypart(sgnj,sgnk)=xmsq_bypart(sgnj,sgnk)+(xmsq-tmp)
      endif
      
 20   continue

      enddo
      enddo


      if (currentPDF == 0) then
        virtint=flux*xjac*pswt*xmsq/BrnRat
      endif
            
c--- loop over all PDF error sets, if necessary
      if (PDFerrors) then
        PDFwgt(currentPDF)=flux*xjac*pswt*xmsq/BrnRat*wgt/itmx
!$omp atomic
        PDFxsec(currentPDF)=PDFxsec(currentPDF)
     &     +PDFwgt(currentPDF)
        currentPDF=currentPDF+1
        if (currentPDF <= maxPDFsets) goto 777
      endif    

c--- code to check that epsilon poles cancel      
      if (nshot == 1) then
        if (xmsq == 0._dp) goto 999
        xmsq_old=xmsq
        nshot=nshot+1
        epinv=0._dp
        epinv2=0._dp
        goto 12
      elseif (nshot == 2) then
        nshot=nshot+1

        if (abs(xmsq_old/xmsq-1._dp) > 1.e-8_dp) then
!$omp master
          if (rank == 0) then
            write(6,*) 'epsilon fails to cancel'
            write(6,*) 'xmsq (epinv=large) = ',xmsq_old
            write(6,*) 'xmsq (epinv=zero ) = ',xmsq
            write(6,*) 'fractional difference',xmsq/xmsq_old-1d0
            call flush(6)
          endif
!$omp end master
C          stop
          colourchoice=rvcolourchoice
        else
!$omp master
          if (rank == 0) then
            write(6,*) 'Poles cancelled!'
c            write(6,*) 'xmsq (epinv=large) = ',xmsq_old
c            write(6,*) 'xmsq (epinv=zero ) = ',xmsq
c            write(6,*) 'fractional difference',xmsq/xmsq_old-1d0
            call flush(6)
          endif
!$omp end master
c          pause
          colourchoice=rvcolourchoice
        endif
      endif
      
c      if (creatent) then
        wt_gg=xmsq_bypart(0,0)*wgt*flux*xjac*pswt/BrnRat/real(itmx,dp)
        wt_gq=(xmsq_bypart(+1,0)+xmsq_bypart(-1,0)
     &        +xmsq_bypart(0,+1)+xmsq_bypart(0,-1)
     &        )*wgt*flux*xjac*pswt/BrnRat/real(itmx,dp)
        wt_qq=(xmsq_bypart(+1,+1)+xmsq_bypart(-1,-1)
     &        )*wgt*flux*xjac*pswt/BrnRat/real(itmx,dp)
        wt_qqb=(xmsq_bypart(+1,-1)+xmsq_bypart(-1,+1)
     &        )*wgt*flux*xjac*pswt/BrnRat/real(itmx,dp)
c      endif

      call getptildejet(0,pjet)
      
      call dotem(nvec,pjet,s)

      val=wgt*flux*xjac*pswt/BrnRat
      do j=-1,1
      do k=-1,1
!$omp atomic
         lord_bypart(j,k)=lord_bypart(j,k)+
     &       val*xmsq_bypart(j,k)
      enddo
      enddo


      if(virtint.ne.virtint) then
         write(6,*) 'Found virtint=',virtint
         write(6,*) 'random #s',r
         virtint=zip
         goto 999
      endif
      val=virtint*wgt 
      val2=val**2 
c---  SSbegin
      virtint = virtint*reweight
c---  SSend
c--- update the maximum weight so far, if necessary
      if (abs(val) > wtmax) then
!$omp critical(MaxWgt)
        wtmax=abs(val)
!$omp end critical(MaxWgt)
      endif

      if (bin) then
         call nplotter(pjet,val,val2,0)
c--- POWHEG-style output if requested
      endif

c--- handle special caase of Qflag and Gflag
      if (QandGflag) then
        QandGint=QandGint+virtint
        if ((Gflag) .and. (.not.(Qflag))) then
c--- go back for second pass (Qflag)
        Qflag=.true.
        Gflag=.false.
        goto 44
      else
c--- return both to .true. and assign value to virtint (to return to VEGAS)
        Qflag=.true.
        Gflag=.true.
        virtint=QandGint
      endif
      endif
      
      return

 999  continue
      virtint=0._dp
!$omp atomic
      ntotzero=ntotzero+1
c--- safety catch
      if (QandGflag) then
        Qflag=.true.
        Gflag=.true.
      endif
      
      return
      end


