c---  RB MODIFY: NOTE THAT THIS FOLLOWS EQ. A.7 and A.9 OF 1401.5478 AND HAS 2*ALPHAS/4/PI EXTRACTED
c---  THE 2 APPEARS IN A.7
c--- END RB MODIFY
      subroutine xI1qiqi(z,I1qiqi)
       
      implicit none
      include 'types.f'       
      include 'constants.f'       
      real(dp), intent(in) :: z
      real(dp) :: I1qiqi(0:2)

c--- coefficient of delta(1-z)
      I1qiqi(0) = -pisq/6.0_dp
c--- coefficient of 1/(1-z)+
      I1qiqi(1) = 1.0_dp+z**2
c--- regular term
      I1qiqi(2) = 1.0_dp-z-(1.0_dp+z**2)/(1.0_dp-z)*log(z)
       
      I1qiqi(:) = CF*I1qiqi(:)
       
      return
      end

c---  RB MODIFY: IMPLEMENT POLARIZED QQ FROM EQ. 49 OF 1704.05457
c---  ONE MODIFICATION: EXTRACT OVERALL 2 FOLLOWING UNPOLARIZED CASE      
c---  THIS FACTOR INCLUDED IN XBEAM1BIS.F
      
      subroutine xI1qiqipol(z,I1qiqipol)
       
      implicit none
      include 'types.f'       
      include 'constants.f'       
      real(dp), intent(in) :: z
      real(dp) :: I1qiqipol(0:2)

c--- coefficient of delta(1-z)
      I1qiqipol(0) = -pisq/6.0_dp
c--- coefficient of 1/(1-z)+
      I1qiqipol(1) = 1.0_dp+z**2
c--- regular term
      I1qiqipol(2) = -(1+z**2)*log(z)/(1-z)-3*(1-z)+4*(1-z)
       
      I1qiqipol(:) = CF*I1qiqipol(:)
       
      return
      end
c--- END RB MODIFY
      

c---  RB MODIFY: NOTE THAT THIS FOLLOWS EQ. A.7 and A.9 OF 1401.5478 AND HAS 2*ALPHAS/4/PI EXTRACTED
c---  THE 2 APPEARS IN A.7
c--- END RB MODIFY
      function I1qig(z)
      implicit none
      include 'types.f'       
      include 'constants.f'       
       
      real(dp), intent(in) :: z
      real(dp) :: I1qig
      real(dp) :: fpqg
       
      fpqg = (1-z)**2+z**2
       
      I1qig = fpqg*(log((1-z)/z)-1) + 1.0_dp
       
      I1qig = TR*I1qig
       
      return
      end

c---  RB MODIFY: IMPLEMENT POLARIZED QG FROM EQ. 60 OF 1704.05457
c---  ONE MODIFICATION: EXTRACT OVERALL 2 FOLLOWING UNPOLARIZED CASE, IMPLEMENT WITH OVERALL TR=1/2    
      function I1qigpol(z)
      implicit none
      include 'types.f'       
      include 'constants.f'       
       
      real(dp), intent(in) :: z
      real(dp) :: I1qigpol
       
       
      I1qigpol = (2*z-1)*log((1-z)/z)+2*(1-z)
       
      I1qigpol = TR*I1qigpol
       
      return
      end      
       
c--- END RB MODIFY
