      subroutine lumxmsq_w(p,xx,z1,z2,QB,order,xmsq)
      implicit none
      include 'types.f'
c----Matrix element for W production
C----averaged over initial colours and spins
C For nwz=+1
c     u(-p1)+dbar(-p2)-->W^+(n(p3)+e^+(p4))
C For nwz=-1
c     d(-p1)+ubar(-p2)-->W^-(e^-(p3)+nbar(p4))
c---
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'masses.f'
      include 'ewcouple.f'
      include 'qcdcouple.f'
      include 'scale.f'
      include 'facscale.f'
      include 'ckm.f'
      include 'scet_const.f'
      include 'polarized.f' 
      integer:: j,k,ih1,ih2,m,n,order
      real(dp),intent(out):: xmsq
      real(dp):: p(mxpart,4),s,fac,qqb,qbq,
     & xx(2),soft1(-1:1),soft2(-1:3),hard(2),
     & beama0(-5:5),beamb0(-5:5),
     & beama1(-5:5,-1:1),beamb1(-5:5,-1:1),
     & beama2(-5:5,-1:3),beamb2(-5:5,-1:3),
     & z1,z2,QB(2),lum0,lum1(-1:1),lum2(-1:3),bit,
     & msq(-nf:nf,-nf:nf),assemble
      common/density/ih1,ih2
      s(j,k)=two*(p(j,4)*p(k,4)-p(j,1)*p(k,1)
     &           -p(j,2)*p(k,2)-p(j,3)*p(k,3))

      fac=gw**4*xn
      fac=aveqq*fac/((s(3,4)-wmass**2)**2+(wmass*wwidth)**2)
c---case dbar-u or ubar-d
      qqb=fac*s(1,4)**2
      qbq=fac*s(2,4)**2

      if(pol1.eq.1) then
          qqb = -qqb
          qbq = qbq 
      endif

      call softqqbis(order,soft1,soft2)
      call hardqq(s(1,2),musq,hard)

      if (order >= 0) then
          if(pol1 .eq. 0 ) then
              call fdist(ih1,xx(1),facscale,beama0)
          else
              call fdist1(ih1,xx(1),facscale,beama0)
          endif
      call fdist(ih2,xx(2),facscale,beamb0)
      endif
      if (order >= 1) then
          if(pol1.eq.0) then
              call xbeam1bis(ih1,z1,xx(1),QB(1),beama1)
          else
              call xbeam1bisPol(ih1,z1,xx(1),QB(1),beama1)
          endif
      call xbeam1bis(ih2,z2,xx(2),QB(2),beamb1)
      endif
      if (order >= 2) then
          if(pol1.eq.0) then
              call xbeam2bis(ih1,z1,xx(1),QB(1),beama2)
          else
              call xbeam2bisPol(ih1,z1,xx(1),QB(1),beama2)
          endif
      call xbeam2bis(ih2,z2,xx(2),QB(2),beamb2)
      endif

      xmsq=zip
      do j=-nf,nf
      do k=-nf,nf
      if (j*k >= 0) cycle ! skip gluons, qq, aa
      
      bit=assemble(order,
     & beama0(j),beamb0(k),beama1(j,:),beamb1(k,:),
     & beama2(j,:),beamb2(k,:),soft1,soft2,hard)

      if ((j > 0) .and. (k < 0)) then
        bit=bit*Vsq(j,k)*qqb
      elseif ((j < 0) .and. (k > 0)) then
        bit=bit*Vsq(j,k)*qbq
      else
        bit=zip
      endif

      xmsq=xmsq+bit

      enddo
      enddo

      return
      end
