      subroutine qqb_w(p,msq)
      implicit none
      include 'types.f'
      
c----Matrix element for W production
C----averaged over initial colours and spins
C For nwz=+1
c     u(-p1)+dbar(-p2)-->W^+(n(p3)+e^+(p4))
C For nwz=-1
c     d(-p1)+ubar(-p2)-->W^-(e^-(p3)+nbar(p4))
c---
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'masses.f'
      include 'ewcouple.f'
      include 'ckm.f'
      integer:: j,k
      real(dp):: msq(-nf:nf,-nf:nf),p(mxpart,4),fac,qqb,qbq,s
     
c--statement function 
      s(j,k)=two*(p(j,4)*p(k,4)-p(j,1)*p(k,1)
     &           -p(j,2)*p(k,2)-p(j,3)*p(k,3))

      fac=gw**4*xn
c--   calculate propagator
      fac=aveqq*fac/((s(3,4)-wmass**2)**2+(wmass*wwidth)**2)
c---case dbar-u or ubar-d
      qqb=fac*s(1,4)**2
      qbq=fac*s(2,4)**2

      do j=-nf,nf
      do k=-nf,nf
c--set msq=0 to initalize
      msq(j,k)=zip
          if ((j > 0) .and. (k < 0)) then
            msq(j,k)=Vsq(j,k)*qqb
          elseif ((j < 0) .and. (k > 0)) then
            msq(j,k)=Vsq(j,k)*qbq
          endif
      enddo
      enddo
      return
      end
      
      subroutine qqb_wPol(p,msq)
      implicit none
      include 'types.f'
      
c----Matrix element for W production
C----averaged over initial colours and spins
C For nwz=+1
c     u(-p1)+dbar(-p2)-->W^+(n(p3)+e^+(p4))
C For nwz=-1
c     d(-p1)+ubar(-p2)-->W^-(e^-(p3)+nbar(p4))
c---
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'masses.f'
      include 'ewcouple.f'
      include 'ckm.f'
      integer:: j,k
      real(dp):: msq(-nf:nf,-nf:nf, -1:1,-1:1),p(mxpart,4),fac,qqb,qbq,s
     
c--statement function 
      s(j,k)=two*(p(j,4)*p(k,4)-p(j,1)*p(k,1)
     &           -p(j,2)*p(k,2)-p(j,3)*p(k,3))


      fac=gw**4*xn
c--   calculate propagator
      fac=aveqq*fac/((s(3,4)-wmass**2)**2+(wmass*wwidth)**2)
c---case dbar-u or ubar-d
c---  a factor of 4, without spin average factor 
      qqb=fac*s(1,4)**2*4d0
      qbq=fac*s(2,4)**2*4d0

      msq = 0d0
c---  msq for ++ and -- is zero 
c---  for q qbar only -+ is nozero 
c---  for qbar q only +- is nozero 
      do j=-nf,nf
      do k=-nf,nf
c--set msq=0 to initalize
      msq(j,k,:,:)=zip
          if ((j > 0) .and. (k < 0)) then
            msq(j,k,-1, 1)=Vsq(j,k)*qqb
          elseif ((j < 0) .and. (k > 0)) then
            msq(j,k,1, -1)=Vsq(j,k)*qbq
          endif
      enddo
      enddo
      return
      end
      

!--------------      
!----------- matrix element square for initial state helicity ip1, ip2
!-----------  ip1 = +1, -1;  ip2 = +1, -1 
      subroutine POLqqb_w(ip1, ip2, p,msq)
      implicit none
      include 'types.f'
      
c----Matrix element for W production
C----averaged over initial colours and spins
C For nwz=+1
c     u(-p1)+dbar(-p2)-->W^+(n(p3)+e^+(p4))
C For nwz=-1
c     d(-p1)+ubar(-p2)-->W^-(e^-(p3)+nbar(p4))
c---
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'masses.f'
      include 'ewcouple.f'
      include 'ckm.f'
      integer:: j,k
      integer:: ip1, ip2 
      real(dp):: msq(-nf:nf,-nf:nf),p(mxpart,4),fac,qqb,qbq,s
     
c--statement function 
      s(j,k)=two*(p(j,4)*p(k,4)-p(j,1)*p(k,1)
     &           -p(j,2)*p(k,2)-p(j,3)*p(k,3))
      
      msq = 0d0
      ! for W production, amplitude for ++ and -- is zero  
      if(ip1.eq.ip2) return 

      fac=gw**4*xn
c--   calculate propagator
      fac=aveqq*fac/((s(3,4)-wmass**2)**2+(wmass*wwidth)**2)
c---case dbar-u or ubar-d
c---  a factor of 4, without spin average factor 
      qqb=fac*s(1,4)**2
      qbq=fac*s(2,4)**2

      msq = 0d0
c---  msq for ++ and -- is zero 
c---  for q qbar only -+ is nozero 
c---  for qbar q only +- is nozero 
      do j=-nf,nf
      do k=-nf,nf
c--set msq=0 to initalize
      msq(j,k)=zip
          if ((j > 0) .and. (k < 0)) then
              ! q(-) + qbar(+) 
              if(ip1.eq.-1 .and. ip2.eq.1)  msq(j,k)=Vsq(j,k)*qqb
          elseif ((j < 0) .and. (k > 0)) then
              ! qbar(+) + q() 
              if(ip1.eq.1 .and. ip2 .eq. -1) msq(j,k)=Vsq(j,k)*qbq
          endif
      enddo
      enddo
      return
      end

!--------------      
!----------- matrix element square for initial state helicity ip1, ip2
!-----------  ip1 = +1, -1;  ip2 = +1, -1 
      subroutine Delta_qqb_w( p,msq)
      implicit none
      include 'types.f'
c----Matrix element for W production
C----averaged over initial colours and spins
C For nwz=+1
c     u(-p1)+dbar(-p2)-->W^+(n(p3)+e^+(p4))
C For nwz=-1
c     d(-p1)+ubar(-p2)-->W^-(e^-(p3)+nbar(p4))
c---
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'masses.f'
      include 'ewcouple.f'
      include 'ckm.f'
      integer:: j,k
      integer:: ip1, ip2 
      real(dp):: msq(-nf:nf,-nf:nf),p(mxpart,4)
      real(dp):: msq0(-nf:nf, -nf:nf)

      msq0 = 0d0
      msq  = 0d0
      call POLqqb_w(1,1,p,msq0)
      msq = msq0
      call POLqqb_w(1,-1,p,msq0)
      msq = msq+msq0
      call POLqqb_w(-1,1,p,msq0)
      msq = msq-msq0
      call POLqqb_w(-1,-1,p,msq0)
      msq = msq-msq0

      msq = msq

      end
     
