      subroutine qqb_w_g(p,msq)
      implicit none
      include 'types.f'
      
c----Matrix element for W production
C----averaged over initial colours and spins
C for nwz=+1
c     u(-p1)+dbar(-p2)--> W^+(n(p3)+e^+(p4))   + g(p5)
C For nwz=-1
c     d(-p1)+ubar(-p2)--> W^-(e^-(p3)+nbar(p4))+ g(p5) 
c---
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'ckm.f'
      include 'ewcouple.f'
      include 'qcdcouple.f'
      include 'sprods_com.f'
      integer:: j,k
      real(dp):: msq(-nf:nf,-nf:nf),p(mxpart,4),fac
      real(dp):: qqbWg,qbqWg,qgWq,qbgWqb,gqbWqb,gqWq,w1jet

      do j=-nf,nf
      do k=-nf,nf
      msq(j,k)=zip
      enddo
      enddo

      call dotem(5,p,s)
c---calculate the propagator
      fac=gwsq**2*gsq*V

      qqbWg= +aveqq*fac*w1jet(1,2,3,4,5)
      gqbWqb=-aveqg*fac*w1jet(5,2,3,4,1)
      qgWq=  -aveqg*fac*w1jet(1,5,3,4,2)
      
      qbqWg= +aveqq*fac*w1jet(2,1,3,4,5)
      qbgWqb=-aveqg*fac*w1jet(5,1,3,4,2)
      gqWq=  -aveqg*fac*w1jet(2,5,3,4,1)

      do j=-nf,nf
      do k=-nf,nf
      if     ((j > 0) .and. (k < 0)) then
          msq(j,k)=Vsq(j,k)*qqbWg
      elseif ((j < 0) .and. (k > 0)) then
          msq(j,k)=Vsq(j,k)*qbqWg
      elseif ((j > 0) .and. (k == 0)) then
          msq(j,k)=
     &   (Vsq(j,-1)+Vsq(j,-2)+Vsq(j,-3)+Vsq(j,-4)+Vsq(j,-5))*qgWq
      elseif ((j < 0) .and. (k == 0)) then
          msq(j,k)=
     &    (Vsq(j,+1)+Vsq(j,+2)+Vsq(j,+3)+Vsq(j,+4)+Vsq(j,+5))*qbgWqb
      elseif ((j == 0) .and. (k > 0)) then
          msq(j,k)=
     &    (Vsq(-1,k)+Vsq(-2,k)+Vsq(-3,k)+Vsq(-4,k)+Vsq(-5,k))*gqWq
      elseif ((j == 0) .and. (k < 0)) then
          msq(j,k)=
     &    (Vsq(+1,k)+Vsq(+2,k)+Vsq(+3,k)+Vsq(+4,k)+Vsq(+5,k))*gqbWqb
      endif

      enddo
      enddo
      return
      end
 
      function w1jet(j1,j2,j3,j4,j5)
      implicit none
      include 'types.f'
      real(dp):: w1jet
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'masses.f'
      include 'sprods_com.f'
      integer:: j1,j2,j3,j4,j5
      real(dp):: prop

      prop=((s(j3,j4)-wmass**2)**2+(wmass*wwidth)**2)

      w1jet=(s(j1,j4)**2+s(j2,j3)**2)*s(j3,j4)/(s(j1,j5)*s(j2,j5)*prop)

      return
      end

!--------------      
!----------- matrix element square for initial state helicity ip1, ip2
!-----------  ip1 = +1, -1;  ip2 = +1, -1 
      subroutine POLqqb_w_g(ip1, ip2, p,msq)
      implicit none
      include 'types.f'
      
c----Matrix element for W production
C----averaged over initial colours and spins
C for nwz=+1
c     u(-p1)+dbar(-p2)--> W^+(n(p3)+e^+(p4))   + g(p5)
C For nwz=-1
c     d(-p1)+ubar(-p2)--> W^-(e^-(p3)+nbar(p4))+ g(p5) 
c---
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'ckm.f'
      include 'ewcouple.f'
      include 'qcdcouple.f'
      include 'sprods_com.f'
      integer:: j,k, ip1, ip2 
      real(dp):: msq(-nf:nf,-nf:nf),p(mxpart,4),fac
      real(dp):: qqbWg,qbqWg,qgWq,qbgWqb,gqbWqb,gqWq,w1jet,POLw1jet

      do j=-nf,nf
      do k=-nf,nf
      msq(j,k)=zip
      enddo
      enddo

      call dotem(5,p,s)
c---calculate the propagator
      fac=gwsq**2*gsq*V
   
      qqbWg    = 0d0
      gqbWqb   = 0d0
      qgWq     = 0d0
      qbqWg    = 0d0
      qbgWqb   = 0d0
      gqWq     = 0d0
     
      if(ip1.eq.-1.and.ip2.eq.1) qqbWg= +aveqq*fac*w1jet(1,2,3,4,5)
      if(ip2.eq.1)  gqbWqb=-aveqg*fac*POLw1jet(ip1,5,2,3,4,1)
      if(ip1.eq.-1) qgWq  =-aveqg*fac*POLw1jet(ip2,1,5,3,4,2)
      
      if(ip1.eq.1.and.ip2.eq.-1) qbqWg= +aveqq*fac*w1jet(2,1,3,4,5)
      if(ip1.eq.1)  qbgWqb=-aveqg*fac*POLw1jet(ip2,5,1,3,4,2)
      if(ip2.eq.-1) gqWq=  -aveqg*fac*POLw1jet(ip1,2,5,3,4,1)

      do j=-nf,nf
      do k=-nf,nf
      if     ((j > 0) .and. (k < 0)) then
          msq(j,k)=Vsq(j,k)*qqbWg
      elseif ((j < 0) .and. (k > 0)) then
          msq(j,k)=Vsq(j,k)*qbqWg
      elseif ((j > 0) .and. (k == 0)) then
          msq(j,k)=
     &   (Vsq(j,-1)+Vsq(j,-2)+Vsq(j,-3)+Vsq(j,-4)+Vsq(j,-5))*qgWq
      elseif ((j < 0) .and. (k == 0)) then
          msq(j,k)=
     &    (Vsq(j,+1)+Vsq(j,+2)+Vsq(j,+3)+Vsq(j,+4)+Vsq(j,+5))*qbgWqb
      elseif ((j == 0) .and. (k > 0)) then
          msq(j,k)=
     &    (Vsq(-1,k)+Vsq(-2,k)+Vsq(-3,k)+Vsq(-4,k)+Vsq(-5,k))*gqWq
      elseif ((j == 0) .and. (k < 0)) then
          msq(j,k)=
     &    (Vsq(+1,k)+Vsq(+2,k)+Vsq(+3,k)+Vsq(+4,k)+Vsq(+5,k))*gqbWqb
      endif

      enddo
      enddo
      return
      end

      subroutine delta_qqb_w_g( p,msq)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      real(dp):: msq(-nf:nf,-nf:nf),p(mxpart,4)
      real(dp):: msq0(-nf:nf,-nf:nf)
      
      msq   = 0d0
      msq0  = 0d0

      ! spin average was taken in POLqqb_w_g
      ! there is not a factor of 1/4  here 

      call POLqqb_w_g(1,1,p,msq0)
      msq  = msq0
      msq0 = 0d0
      call POLqqb_w_g(1,-1,p,msq0)
      msq  = msq+msq0
      msq0 = 0d0
      call POLqqb_w_g(-1,1,p,msq0)
      msq  = msq-msq0
      msq0 = 0d0
      call POLqqb_w_g(-1,-1,p,msq0)
      msq  = msq-msq0

      end
      
 
      function POLw1jet(ipolg, j1,j2,j3,j4,j5)
      implicit none
      include 'types.f'
      real(dp):: POLw1jet
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'masses.f'
      include 'sprods_com.f'
      integer:: j1,j2,j3,j4,j5, ipolg
      real(dp):: prop

      prop=((s(j3,j4)-wmass**2)**2+(wmass*wwidth)**2)

      POLw1jet = 0d0
      ! ipolg is the polaization of the gluon:
      ! gluon is always in initial state
      ! g+
      if(ipolg.eq.1)  POLw1jet=s(j1,j4)**2*s(j3,j4)/(s(j1,j5)*s(j2,j5)*prop)
      if(ipolg.eq.-1) POLw1jet=s(j2,j3)**2*s(j3,j4)/(s(j1,j5)*s(j2,j5)*prop)

      return
      end

