      subroutine w2jetsq(i1,i2,i3,i4,i5,i6,za,zb,msq)
      implicit none
      include 'types.f'
      
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'zprods_decl.f'
      include 'lc.f'
      include 'mmsq_cs.f'
      complex(dp):: qcd1(-1:1,-1:1),qcd2(-1:1,-1:1),qed(-1:1,-1:1)
      real(dp):: msq1,msq2,msqq,msq
      integer:: i1,i2,i3,i4,i5,i6

      call subqcd(i1,i2,i3,i4,i5,i6,za,zb,qcd1)
      call subqcd(i1,i2,i3,i4,i6,i5,za,zb,qcd2)

      qed(+1,+1)=qcd1(+1,+1)+qcd2(+1,+1)
      qed(+1,-1)=qcd1(+1,-1)+qcd2(-1,+1)
      qed(-1,+1)=qcd1(-1,+1)+qcd2(+1,-1)
      qed(-1,-1)=qcd1(-1,-1)+qcd2(-1,-1)

      msq1= abs(qcd1(+1,+1))**2+abs(qcd1(+1,-1))**2
     &     +abs(qcd1(-1,+1))**2+abs(qcd1(-1,-1))**2

      msq2= abs(qcd2(+1,+1))**2+abs(qcd2(+1,-1))**2
     &     +abs(qcd2(-1,+1))**2+abs(qcd2(-1,-1))**2

      msqq= abs( qed(+1,+1))**2+abs( qed(+1,-1))**2
     &     +abs( qed(-1,+1))**2+abs( qed(-1,-1))**2

      mmsq_cs(0,0,0)=0._dp
      mmsq_cs(1,0,0)=0._dp
      mmsq_cs(2,0,0)=0._dp

      if ((colourchoice == 1) .or. (colourchoice == 0)) then
      mmsq_cs(1,0,0)=msq1
      mmsq_cs(2,0,0)=msq2
      endif
      if ((colourchoice == 2) .or. (colourchoice == 0)) then
      mmsq_cs(0,0,0)=-ninth*msqq
      endif
            
      msq=mmsq_cs(0,0,0)+mmsq_cs(1,0,0)+mmsq_cs(2,0,0)
      
      return
      end
      

      subroutine POLw2jetsq(i1,i2,i3,i4,i5,i6,za,zb,msqPOL)
      implicit none
      !
      ! msqPOL(0:2,-1:1,-1:1), keep the orginal 0:2 in mmsq_sc 
      ! (-1:1,-1:1) tracks the helicity of the gluon
      ! msqPol(0:2,0,0) is the summation over all the helicities 
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'zprods_decl.f'
      include 'lc.f'
      include 'mmsq_cs.f'
      complex(dp):: qcd1(-1:1,-1:1),qcd2(-1:1,-1:1),qed(-1:1,-1:1)
      real(dp):: msq1,msq2,msqq,msq, msqPOL(0:2,-1:1,-1:1)
      real(dp):: m1(-1:1,-1:1), m2(-1:1,-1:1), mq(-1:1,-1:1)
      integer:: i1,i2,i3,i4,i5,i6
      integer:: i, j

      call subqcd(i1,i2,i3,i4,i5,i6,za,zb,qcd1)
      call subqcd(i1,i2,i3,i4,i6,i5,za,zb,qcd2)

      qed(+1,+1)=qcd1(+1,+1)+qcd2(+1,+1)
      qed(+1,-1)=qcd1(+1,-1)+qcd2(-1,+1)
      qed(-1,+1)=qcd1(-1,+1)+qcd2(+1,-1)
      qed(-1,-1)=qcd1(-1,-1)+qcd2(-1,-1)

      msq1= abs(qcd1(+1,+1))**2+abs(qcd1(+1,-1))**2
     &     +abs(qcd1(-1,+1))**2+abs(qcd1(-1,-1))**2

      msq2= abs(qcd2(+1,+1))**2+abs(qcd2(+1,-1))**2
     &     +abs(qcd2(-1,+1))**2+abs(qcd2(-1,-1))**2

      msqq= abs( qed(+1,+1))**2+abs( qed(+1,-1))**2
     &     +abs( qed(-1,+1))**2+abs( qed(-1,-1))**2

      mmsq_cs(0,0,0)=0._dp
      mmsq_cs(1,0,0)=0._dp
      mmsq_cs(2,0,0)=0._dp

      m1  = 0._dp
      m2  = 0._dp
      mq  = 0._dp

      if ((colourchoice == 1) .or. (colourchoice == 0)) then
      mmsq_cs(1,0,0)=msq1
      mmsq_cs(2,0,0)=msq2
      do i=-1,1,2
      do j=-1,1,2
          m1(i,j) = abs(qcd1(i,j))**2
          m2(i,j) = abs(qcd2(j,i))**2
      enddo
      enddo
      m1(0,0) = msq1 
      m2(0,0) = msq2 
      endif
      if ((colourchoice == 2) .or. (colourchoice == 0)) then
      mmsq_cs(0,0,0)=-ninth*msqq
      do i=-1,1,2
      do j=-1,1,2
          mq(i,j) = -ninth*abs(qed(i,j))**2
      enddo
      enddo
      mq(0,0) = -ninth*msqq
      endif
          
      msq=mmsq_cs(0,0,0)+mmsq_cs(1,0,0)+mmsq_cs(2,0,0)

      msqPOL(1,:,:) = m1(:,:)
      msqPOL(2,:,:) = m2(:,:)
      msqPOL(0,:,:) = mq(:,:)
      
      return
      end
